lapd_datalink Struct Reference
LAPD implementation common part

LAPD datalink. More...

`#include <lapd_core.h>`

## Data Fields

int(* | send_dlsap )(struct osmo_dlsap_prim *dp, struct lapd_msg_ctx *lctx)
int(* | send_ph_data_req )(struct lapd_msg_ctx *lctx, struct msgb *msg)
int(* | update_pending_frames )(struct lapd_msg_ctx *lctx)
struct {
struct lapd_cr_ent loc2rem
| filled-in once we set the lapd_mode above
struct lapd_cr_ent rem2loc
} | cr
enum lapd_mode | mode
| current mode of link
int | use_sabme
| use SABME instead of SABM
int | reestablish
| enable reestablish support
int | n200
int | n200_est_rel
| number of retranmissions
struct lapd_msg_ctx | lctx
| LAPD context.
int | maxf
| maximum frame size (after defragmentation)
uint8_t | k
| maximum number of unacknowledged frames
uint8_t | v_range
| range of sequence numbers
uint8_t | v_send
| seq nr of next I frame to be transmitted
uint8_t | v_ack
| last frame ACKed by peer
uint8_t | v_recv
| seq nr of next I frame expected to be received
uint32_t | state
| LAPD state (lapd_state)
int | seq_err_cond
| condition of sequence error
uint8_t | own_busy
| receiver busy on our side
uint8_t | peer_busy
| receiver busy on remote side
int | t200_sec
int | t200_usec
| retry timer (default 1 sec)
int | t203_sec
int | t203_usec
| retry timer (default 10 secs)
struct osmo_timer_list | t200
| T200 timer.
struct osmo_timer_list | t203
| T203 timer.
uint8_t | retrans_ctr
| re-transmission counter
struct llist_head | tx_queue
| frames to L1
struct llist_head | send_queue
| frames from L3
struct msgb * | send_buffer
| current frame transmitting
int | send_out
| how much was sent from send_buffer
struct lapd_history * | tx_hist
| tx history structure array
uint8_t | range_hist
| range of history buffer 2..2^n
struct msgb * | rcv_buffer
| buffer to assemble the received message
struct msgb * | cont_res
| buffer to store content resolution data on network side, to detect multiple phones on same channel

## Detailed Description

LAPD datalink.

The documentation for this struct was generated from the following file:

- include/osmocom/gsm/lapd_core.h